UIPackage
Menu

Framework

Change language

Boilerplate repo

Alert Modal

alert-modalui

Props-driven shortcut for confirm and destructive prompts — pass `title`, `description`, `actionLabel`, and a `tone` and you get a fully styled modal with a leading icon ring, action button, and optional async loading state. Skip it and use Dialog when you need a free-form modal instead.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/alert-modal.json
Named registry:npx shadcn@latest add @uipkge-react/alert-modalInstalls to:components/ui/alert-modal/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
open

Controlled open state. Pair with `onOpenChange`.

booleanoptional
onOpenChange(open: boolean) => voidoptional
title

Title rendered in the header. Override with the `title` node if you need markup.

React.ReactNodeoptional
description

Description rendered under the title.

React.ReactNodeoptional
actionLabel

Label for the primary action button.

React.ReactNodeoptional
cancelLabel

Label for the cancel button. Pass null to hide.

React.ReactNode | nulloptional
tone

Visual tone — colors the icon and action button.

'default' | 'destructive' | 'success' | 'warning'optional
icon

Quick icon shortcut, a custom icon component, or a rendered node.

AlertIcon | LucideIcon | React.ReactNode | nulloptional
loading

Show a spinner on the action button and disable both buttons.

booleanoptional
actionDisabled

Disable the primary action without a spinner.

booleanoptional
classNamestringoptional
onAction(event: React.MouseEvent) => voidoptional
onCancel(event: React.MouseEvent) => voidoptional
trigger

Element that opens the modal. Rendered as the trigger when provided.

React.ReactNodeoptional
children

Optional free-form body content between the header and the action row.

React.ReactNodeoptional
actions

Replace the default action/cancel button row.

React.ReactNodeoptional

npm dependencies

Includes

Files installed (2)

  • components/ui/alert-modal/alert-modal.tsx6 kB
    'use client'
    
    import * as React from 'react'
    import { CircleAlert, CircleCheck, Info, TriangleAlert, type LucideIcon } from 'lucide-react'
    import {
      Dialog,
      DialogClose,
      DialogContent,
      DialogDescription,
      DialogTitle,
      DialogTrigger,
    } from '@/components/ui/dialog'
    import { cn } from '@/lib/utils'
    import { Button } from '@/components/ui/button'
    
    type AlertIcon = 'info' | 'warning' | 'error' | 'success'
    
    export interface AlertModalProps {
      /** Controlled open state. Pair with `onOpenChange`. */
      open?: boolean
      onOpenChange?: (open: boolean) => void
      /** Title rendered in the header. Override with the `title` node if you need markup. */
      title?: React.ReactNode
      /** Description rendered under the title. */
      description?: React.ReactNode
      /** Label for the primary action button. */
      actionLabel?: React.ReactNode
      /** Label for the cancel button. Pass null to hide. */
      cancelLabel?: React.ReactNode | null
      /** Visual tone — colors the icon and action button. */
      tone?: 'default' | 'destructive' | 'success' | 'warning'
      /** Quick icon shortcut, a custom icon component, or a rendered node. */
      icon?: AlertIcon | LucideIcon | React.ReactNode | null
      /** Show a spinner on the action button and disable both buttons. */
      loading?: boolean
      /** Disable the primary action without a spinner. */
      actionDisabled?: boolean
      className?: string
      onAction?: (event: React.MouseEvent) => void
      onCancel?: (event: React.MouseEvent) => void
      /** Element that opens the modal. Rendered as the trigger when provided. */
      trigger?: React.ReactNode
      /** Optional free-form body content between the header and the action row. */
      children?: React.ReactNode
      /** Replace the default action/cancel button row. */
      actions?: React.ReactNode
    }
    
    const builtInIcons: Record<AlertIcon, LucideIcon> = {
      info: Info,
      success: CircleCheck,
      warning: TriangleAlert,
      error: CircleAlert,
    }
    
    function isAlertIcon(value: unknown): value is AlertIcon {
      return value === 'info' || value === 'success' || value === 'warning' || value === 'error'
    }
    
    const iconColorClasses: Record<NonNullable<AlertModalProps['tone']>, string> = {
      destructive: 'text-destructive',
      success: 'text-success',
      warning: 'text-warning',
      default: 'text-muted-foreground',
    }
    
    const actionToneClasses: Record<NonNullable<AlertModalProps['tone']>, string> = {
      destructive: 'bg-destructive text-destructive-foreground hover:bg-destructive/90',
      success: 'bg-success text-success-foreground hover:bg-success/90',
      warning: 'bg-warning text-warning-foreground hover:bg-warning/90',
      default: '',
    }
    
    const AlertModal = ({
      open,
      onOpenChange,
      title = '',
      description = '',
      actionLabel = 'Continue',
      cancelLabel = 'Cancel',
      tone = 'default',
      icon = null,
      loading = false,
      actionDisabled = false,
      className,
      onAction,
      onCancel,
      trigger,
      children,
      actions,
    }: AlertModalProps) => {
      const isControlled = open !== undefined
      const [internalOpen, setInternalOpen] = React.useState<boolean>(open ?? false)
      const effectiveOpen = isControlled ? open : internalOpen
    
      function setOpen(value: boolean) {
        // Keep the dialog open while an async action is in flight.
        if (!value && loading) return
        if (!isControlled) setInternalOpen(value)
        onOpenChange?.(value)
      }
    
      const resolvedIcon = React.useMemo<React.ReactNode>(() => {
        if (!icon) return null
        if (isAlertIcon(icon)) {
          const IconComp = builtInIcons[icon]
          return <IconComp className="size-5" />
        }
        if (typeof icon === 'function') {
          const IconComp = icon as LucideIcon
          return <IconComp className="size-5" />
        }
        return icon
      }, [icon])
    
      function handleAction(e: React.MouseEvent) {
        if (loading || actionDisabled) {
          e.preventDefault()
          return
        }
        onAction?.(e)
      }
    
      function handleCancel(e: React.MouseEvent) {
        onCancel?.(e)
      }
    
      return (
        <Dialog open={effectiveOpen} onOpenChange={setOpen}>
          {trigger && <DialogTrigger asChild>{trigger}</DialogTrigger>}
    
          <DialogContent
            role="alertdialog"
            showCloseButton={false}
            className={cn(className)}
            // Alert dialogs must not soft-dismiss on outside click (WAI-ARIA).
            onPointerDownOutside={(e) => e.preventDefault()}
            onInteractOutside={(e) => e.preventDefault()}
          >
            <div className="flex flex-col gap-2 text-center sm:text-left">
              {resolvedIcon && (
                <div
                  className={cn(
                    'bg-muted mb-2 flex size-10 items-center justify-center rounded-full',
                    iconColorClasses[tone],
                  )}
                >
                  {resolvedIcon}
                </div>
              )}
              <DialogTitle className="text-lg font-semibold">{title}</DialogTitle>
              {description && (
                <DialogDescription className="text-muted-foreground text-sm">{description}</DialogDescription>
              )}
            </div>
    
            {children && <div className="text-sm">{children}</div>}
    
            <div className="flex flex-col-reverse gap-2 sm:flex-row sm:justify-end">
              {actions ?? (
                <>
                  {cancelLabel != null && (
                    <DialogClose asChild>
                      <Button variant="outline" disabled={loading} onClick={handleCancel}>
                        {cancelLabel}
                      </Button>
                    </DialogClose>
                  )}
                  <Button
                    disabled={loading || actionDisabled}
                    aria-busy={loading}
                    className={actionToneClasses[tone]}
                    onClick={handleAction}
                  >
                    {loading && (
                      <span
                        className="mr-2 inline-block size-3.5 animate-spin rounded-full border-2 border-current border-t-transparent"
                        aria-hidden="true"
                      />
                    )}
                    {actionLabel}
                  </Button>
                </>
              )}
            </div>
          </DialogContent>
        </Dialog>
      )
    }
    AlertModal.displayName = 'AlertModal'
    
    export { AlertModal }
    
  • components/ui/alert-modal/index.ts0.1 kB

Raw manifest:https://uipkge.dev/r/react/alert-modal.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Alert Modal

alert-modalui

Props-driven shortcut for confirm and destructive prompts — pass `title`, `description`, `actionLabel`, and a `tone` and you get a fully styled modal with a leading icon ring, action button, and optional async loading state. Skip it and use Dialog when you need a free-form modal instead.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/alert-modal.json
Named registry:npx shadcn-vue@latest add @uipkge/alert-modalInstalls to:app/components/ui/alert-modal/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
open

Controlled open state. Pair with v-model:open.

booleanoptional
title

Title rendered in the header. Override with #title slot.

string''optional
description

Description rendered under the title. Override with #description slot.

string''optional
actionLabel

Label for the primary action button.

string'Continue'optional
cancelLabel

Label for the cancel button. Pass null to hide.

string | null'Cancel'optional
tone

Visual tone — colors the icon and action button.

'default''destructive''success''warning'
'default'optional
icon

Quick icon shortcut. Override with #icon slot.

AlertIcon | Component | nulloptional
loading

Show a spinner on the action button and disable both buttons.

booleanfalseoptional
actionDisabled

Disable the primary action without a spinner.

booleanfalseoptional
classHTMLAttributes['class']optional

npm dependencies

Includes

Files installed (2)

  • app/components/ui/alert-modal/AlertModal.vue6.1 kB
    <script setup lang="ts">
    import { computed, ref, watch } from 'vue'
    import type { Component, HTMLAttributes } from 'vue'
    import { CircleAlert, CircleCheck, Info, TriangleAlert } from 'lucide-vue-next'
    import {
      AlertDialogAction,
      AlertDialogCancel,
      AlertDialogContent,
      AlertDialogDescription,
      AlertDialogOverlay,
      AlertDialogPortal,
      AlertDialogRoot,
      AlertDialogTitle,
      AlertDialogTrigger,
    } from 'reka-ui'
    import { cn } from '@/lib/utils'
    import { Button } from '@/components/ui/button'
    
    type AlertIcon = 'info' | 'warning' | 'error' | 'success'
    
    const props = withDefaults(
      defineProps<{
        /** Controlled open state. Pair with v-model:open. */
        open?: boolean
        /** Title rendered in the header. Override with #title slot. */
        title?: string
        /** Description rendered under the title. Override with #description slot. */
        description?: string
        /** Label for the primary action button. */
        actionLabel?: string
        /** Label for the cancel button. Pass null to hide. */
        cancelLabel?: string | null
        /** Visual tone — colors the icon and action button. */
        tone?: 'default' | 'destructive' | 'success' | 'warning'
        /** Quick icon shortcut. Override with #icon slot. */
        icon?: AlertIcon | Component | null
        /** Show a spinner on the action button and disable both buttons. */
        loading?: boolean
        /** Disable the primary action without a spinner. */
        actionDisabled?: boolean
        class?: HTMLAttributes['class']
      }>(),
      {
        title: '',
        description: '',
        actionLabel: 'Continue',
        cancelLabel: 'Cancel',
        tone: 'default',
        loading: false,
        actionDisabled: false,
      },
    )
    
    const emit = defineEmits<{
      'update:open': [value: boolean]
      action: [event: MouseEvent]
      cancel: [event: MouseEvent]
    }>()
    
    // Sync internal ref with v-model:open and emit changes back out so the
    // component works in both controlled and uncontrolled modes.
    const internalOpen = ref(props.open ?? false)
    
    watch(
      () => props.open,
      (v) => {
        if (v !== undefined && v !== internalOpen.value) internalOpen.value = v
      },
    )
    
    function setOpen(v: boolean) {
      // Keep the dialog open while an async action is in flight.
      if (!v && props.loading) return
      internalOpen.value = v
      emit('update:open', v)
    }
    
    const builtInIcons: Record<AlertIcon, Component> = {
      info: Info,
      success: CircleCheck,
      warning: TriangleAlert,
      error: CircleAlert,
    }
    
    const ResolvedIcon = computed<Component | null>(() => {
      if (!props.icon) return null
      if (typeof props.icon === 'string') return builtInIcons[props.icon] ?? null
      return props.icon
    })
    
    const iconColorClass = computed(() => {
      switch (props.tone) {
        case 'destructive':
          return 'text-destructive'
        case 'success':
          return 'text-success'
        case 'warning':
          return 'text-warning'
        default:
          return 'text-muted-foreground'
      }
    })
    
    const actionToneClass = computed(() => {
      switch (props.tone) {
        case 'destructive':
          return 'bg-destructive text-destructive-foreground hover:bg-destructive/90'
        case 'success':
          return 'bg-success text-success-foreground hover:bg-success/90'
        case 'warning':
          return 'bg-warning text-warning-foreground hover:bg-warning/90'
        default:
          return ''
      }
    })
    
    function handleAction(e: MouseEvent) {
      if (props.loading || props.actionDisabled) {
        e.preventDefault()
        return
      }
      emit('action', e)
    }
    
    function handleCancel(e: MouseEvent) {
      emit('cancel', e)
    }
    </script>
    
    <template>
      <AlertDialogRoot :open="internalOpen" @update:open="setOpen">
        <AlertDialogTrigger v-if="$slots.trigger" as-child>
          <slot name="trigger" />
        </AlertDialogTrigger>
    
        <AlertDialogPortal>
          <AlertDialogOverlay
            class="data-[state=open]:animate-in data-[state=closed]:animate-out data-[state=closed]:fade-out-0 data-[state=open]:fade-in-0 fixed inset-0 z-50 bg-neutral-900/80"
          />
          <AlertDialogContent
            :class="
              cn(
                'bg-background data-[state=open]:animate-in data-[state=closed]:animate-out data-[state=closed]:fade-out-0 data-[state=open]:fade-in-0 data-[state=closed]:zoom-out-95 data-[state=open]:zoom-in-95 fixed top-[50%] left-[50%] z-50 grid w-full max-w-[calc(100%-2rem)] translate-x-[-50%] translate-y-[-50%] gap-4 rounded-lg border p-6 shadow-lg duration-200 sm:max-w-lg',
                props.class,
              )
            "
          >
            <div class="flex flex-col gap-2 text-center sm:text-left">
              <div
                v-if="$slots.icon || ResolvedIcon"
                :class="cn('bg-muted mb-2 flex size-10 items-center justify-center rounded-full', iconColorClass)"
              >
                <slot name="icon">
                  <component :is="ResolvedIcon" v-if="ResolvedIcon" class="size-5" />
                </slot>
              </div>
              <AlertDialogTitle class="text-lg font-semibold">
                <slot name="title">{{ title }}</slot>
              </AlertDialogTitle>
              <AlertDialogDescription v-if="description || $slots.description" class="text-muted-foreground text-sm">
                <slot name="description">{{ description }}</slot>
              </AlertDialogDescription>
            </div>
    
            <div v-if="$slots.default" class="text-sm">
              <slot />
            </div>
    
            <div class="flex flex-col-reverse gap-2 sm:flex-row sm:justify-end">
              <slot name="actions">
                <AlertDialogCancel v-if="cancelLabel" as-child>
                  <Button variant="outline" :disabled="loading" @click="handleCancel">
                    {{ cancelLabel }}
                  </Button>
                </AlertDialogCancel>
                <AlertDialogAction as-child>
                  <Button
                    :disabled="loading || actionDisabled"
                    :aria-busy="loading"
                    :class="actionToneClass"
                    @click="handleAction"
                  >
                    <span
                      v-if="loading"
                      class="mr-2 inline-block size-4 animate-spin rounded-full border-2 border-current border-t-transparent"
                      aria-hidden="true"
                    />
                    {{ actionLabel }}
                  </Button>
                </AlertDialogAction>
              </slot>
            </div>
          </AlertDialogContent>
        </AlertDialogPortal>
      </AlertDialogRoot>
    </template>
    
  • app/components/ui/alert-modal/index.ts0.1 kB

Raw manifest:https://uipkge.dev/r/vue/alert-modal.json